#CapacityRequirement and TaskSkill matrix
import random

def CapacityRequirement(nSkills, nSkillsLow, nSkillsMedium,
                        nSkillsHigh, capMin, capMax, nSkillsMin, nSkillsMax,
                        capPerSkillMin, capPerSkillMax, nTasks, nDuplicates, belongToTaskSleep,
                        belongToTaskRest, belongToTaskDuplicate, nSubResources):


    skillProbabilityDistrubution = generateSkillProbabilityDistrubution(nSkills, nSkillsLow, nSkillsMedium, nSkillsHigh)

    cReqMatrix = [[0]*nSkills for _ in range(nTasks)]
    for n in range(0,nTasks):
        if belongToTaskSleep[n] or belongToTaskRest[n]:
            cReqMatrix[n][0] = nSubResources

        else:
            nSkillsInTask = random.randint(nSkillsMin, nSkillsMax)
            capacityInTask = random.randint(max(capMin, nSkillsInTask*capPerSkillMin), min(capMax, nSkillsInTask*capPerSkillMax))
            skillsInTask = selectSkills(nSkillsInTask, skillProbabilityDistrubution)

            k = 0
            for i in range(0, nSkillsInTask):
                c = random.randint(max(capPerSkillMin, (capacityInTask-k)-(nSkillsInTask-(i+1))*capPerSkillMax),
                                   min(capPerSkillMax, (capacityInTask-k)-(nSkillsInTask-(i+1))*capPerSkillMin))
                k += c
                cReqMatrix[n][skillsInTask[i]-1] += c

    for i in range(nDuplicates,nTasks):                         #Assigns values to the duplicate tasks
        for j in range(1,nDuplicates+1):
            if belongToTaskDuplicate[i] == j+1:
                cReqMatrix[i] = cReqMatrix[j]
    return cReqMatrix

def taskSkills(cReqMatrix):
    taskMatrix = [[0]*len(cReqMatrix[0]) for _ in range(len(cReqMatrix))]
    for i, task in enumerate(cReqMatrix):
        for j, skill in enumerate(task):
            taskMatrix[i][j] = int(skill>0)
    return taskMatrix


def selectSkills(nSkillsInTask, skillProbabilityDistrubution):
    skillsInTask = []
    tempIndexes = []
    while len(skillsInTask) < nSkillsInTask:
        tempIndex = random.randint(0, len(skillProbabilityDistrubution) - 1)
        if tempIndex not in tempIndexes:
            tempIndexes.append(tempIndex)
            if skillsInTask.count(skillProbabilityDistrubution[tempIndex]) < 2:
                skillsInTask.append(skillProbabilityDistrubution[tempIndex])
    return skillsInTask

def generateSkillProbabilityDistrubution(nSkills, nSkillsLow, nSkillsMedium, nSkillsHigh):
    skillProbabilityDistrubution = []
    for n in range(2, nSkills+1):
        if n > nSkillsLow+nSkillsMedium+1:
            for m in range(0, 4): #Skills med høy sannsynlighet får 4x sannsynlighet
                skillProbabilityDistrubution.append(n)
        elif n > nSkillsLow+1:
            for m in range(0, 2): #Skills med medium sannsynlighet får 2x sannsynlighet
                skillProbabilityDistrubution.append(n)
        else:
            skillProbabilityDistrubution.append(n)
    return skillProbabilityDistrubution
