#Tasks

import random
import pprint
import DistanceMatrix
from collections import Counter

def Tasksgen(nTasks, nDuplicates, nEndTime, nLoc, nSkillLevels, long_pntg, tmin_pntg, capres_max_pntg, exc_pntg, div_pntg, prec_pntg, con_pntg, dir_pntg, value_max, ttask_min, DistanceM, maxtaskprec, maxtaskcon, maxtaskdir):
    ndays = nEndTime//24
    long_free_permitted = (nDuplicates-ndays)//2
    Days =[]
    Location =[]
    TempLoc = []
    BelongToTaskSleep =[0]*nTasks
    BelongToTaskDuplicate =[0]*nTasks
    BelongToTaskLong =[0]*nTasks
    BelongToTaskRest =[0]*nTasks
    BelongToTaskDivisible =[0]*nTasks
    BelongToTaskExclusive =[0]*nTasks
    BelongToLocation =[0]*nTasks
    Tmin = [0] * nTasks
    Capmax = [0] * nTasks
    Ttask = [0] * nTasks
    ReleaseTime = [0] * nTasks
    Deadline = [0] * nTasks
    MaximumVisits = [0] * nLoc
    Precedence = [[0 for col in range(nDuplicates)] for row in range(nDuplicates)]
    Connected = [[0 for col in range(nDuplicates)] for row in range(nDuplicates)]
    DirectStart = [[0 for col in range(nDuplicates)] for row in range(nDuplicates)]
    Value = [[0 for col in range(nSkillLevels)] for row in range(nTasks)]

    #distribution data
    longdistr = [1] * int(100*long_pntg) + [0] * int(100*(1-long_pntg))
    excdistr =  [1] * int(100*exc_pntg) + [0] * int(100*(1-exc_pntg))
    divdistr =  [1] * int(100*div_pntg) + [0] * int(100*(1-div_pntg))
    precdistr = [1] * int(100*prec_pntg) + [0] * int(100*(1-prec_pntg))
    condistr =  [1] * int(100*con_pntg) + [0] * int(100*(1-con_pntg))
    dirdistr =  [1] * int(100*dir_pntg) + [0] * int(100*(1-dir_pntg))


    for d in range(ndays):                                  #creates a list of days
        Days.append(d+1)
        BelongToTaskSleep[d] = 1                            #BTTSleep


    t = 1
    nrlongtasks = 0
    while t <(nDuplicates):
        if BelongToTaskSleep[t-1]==1:
            t = t+1
        else:
            if nrlongtasks <= long_free_permitted:         #makes sure that there aren't more long tasks than are feasible
                longval = random.choice(longdistr)
                if longval == 1:
                    nrlongtasks = nrlongtasks + 1
                    BelongToTaskLong[t-1] = 1
                    BelongToTaskLong[t] = 1                #BBTLong
                    BelongToTaskRest[t] = 1                #BBTRest
                    t = t+2
                else:
                    t = t+1
            else:
                break
    restcounter = BelongToTaskRest.count(1)

    for i in range(nDuplicates):                           #BTTExclusive
        if BelongToTaskSleep[i] == 1:
            BelongToTaskExclusive[i]=1
        elif BelongToTaskRest[i] == 1:
            BelongToTaskExclusive[i] =1
        else:
            excval = random.choice(excdistr)
            if excval ==1:
                BelongToTaskExclusive[i]=1


    for i in range(nDuplicates):                           #BTTDivisible
        if BelongToTaskSleep[i] == 1:
            BelongToTaskDivisible[i]=0
        elif BelongToTaskRest[i] == 1:
            BelongToTaskDivisible[i] =0
        elif BelongToTaskLong[i] == 1:
            BelongToTaskDivisible[i] =0
        else:
            divval = random.choice(divdistr)
            if divval ==1:
                BelongToTaskDivisible[i]=1

    for i in range(nDuplicates):                           #Tmin and Capmax
        if BelongToTaskDivisible[i] ==0:
            Tmin[i] =1
            Capmax[i] = 1
        elif BelongToTaskDivisible[i]==1:
            Tmin[i] = round(random.uniform(tmin_pntg,1), 1)
            Capmax[i] = round(random.uniform(1.1,capres_max_pntg), 1)

    for l in range(nLoc):
        Location.append(l+1)
        TempLoc.append(l+1)

    TempLoc.remove(1)
    TempLoc.remove(nLoc)
    TempLoc.remove(2)

    for i in range(nDuplicates):
        if BelongToTaskRest[i] == 1 or BelongToTaskSleep[i]==1:
            BelongToLocation[i] = 2

    for i in range(nDuplicates):                                    # BTLocation
        if BelongToTaskRest[i] == 1 or BelongToTaskSleep[i]==1:
            BelongToLocation[i] = 2
        elif len(TempLoc)!=0:       #Attempts to spread tasks to as many locations as possible
            locval = random.choice(TempLoc)
            BelongToLocation[i] = locval
            TempLoc.remove(locval)
        else:
            locval2 = random.randint(2,len(Location)-1)
            BelongToLocation[i]=locval2

    for i in range(nDuplicates):                                    #Ttask
        ttask_max = 16-2*(DistanceM[1][BelongToLocation[i]-1])
        if ttask_max >1:
            Ttask[i] = random.randint(ttask_min,ttask_max)
        if BelongToTaskSleep[i]==1:
            Ttask[i]=8
        elif BelongToTaskLong[i]==1:
            Ttask[i]=48
        if BelongToTaskRest[i]==1: #overrides Ttask=48 for free tasks
            Ttask[i]=24

    for t in range(nDuplicates):                                         #Value
        for sl in range(nSkillLevels):
            if BelongToTaskRest[t] == 1 or BelongToTaskSleep[t] == 1:
                Value[t][sl] = 0
            else:
                valval = random.randint(1,value_max)
                Value[t][0] = valval
                if valval == 1:
                    Value[t][1] = 1
                else:
                    Value[t][1] = valval-1
    for t in range(nDuplicates):                                         #Value
        for sl in range(nSkillLevels):
            if Ttask[t] >20:
                Value[t][sl] = Value[t][sl] * 20
            else:
                Value[t][sl] = Value[t][sl]*Ttask[t]

    for i in range(nDuplicates-1):                                  #Precedence
        if BelongToTaskLong[i] == 1 and BelongToTaskRest[i+1]==1:
            Precedence[i][i+1] = 1
            Precedence[i+1][i] = 0
    for i in range(nDuplicates):
        if BelongToTaskLong[i] ==0:
            taskhasprec = random.choice(precdistr)
            if taskhasprec == 1:
                counter = 0
                nrofprec = random.randint(1,maxtaskprec)
                while counter < nrofprec:
                    taskprec = random.randint(0,nDuplicates-1)
                    if taskprec != i and BelongToTaskLong[taskprec] ==0:
                        Precedence[i][taskprec] = 1
                        counter +=1

    for i in range(nDuplicates):
        for j in range(nDuplicates):
            if BelongToTaskSleep[i] == 1 or BelongToTaskSleep[j] == 1:  # Sleeptasks can't have precedence
                Precedence[i][j] = 0
            if Precedence[i][j] == 1:  # Precedence can't go both ways between two tasks
                Precedence[j][i] = 0
            if i == j:  # A task can't have precedence over itself
                Precedence[i][j] = 0


    for i in range(nDuplicates - 1):                                # Connected
        if BelongToTaskLong[i] == 1 and BelongToTaskRest[
            i + 1] == 1:  # A long task has to have a rest task connected to it
            Connected[i][i + 1] = 1
            Connected[i + 1][i] = 0
    for i in range(nDuplicates):
        if BelongToTaskLong[i] == 0:
            taskiscon = random.choice(condistr)
            if taskiscon == 1:
                counter = 0
                nrofcon = random.randint(1, maxtaskcon)
                while counter < nrofcon:
                    taskcon = random.randint(0, nDuplicates - 1)
                    if taskcon != i and BelongToTaskLong[taskcon] == 0:
                        Connected[i][taskcon] = 1
                        Connected[taskcon][i] = 1
                        counter += 1

    for i in range(nDuplicates):
        for j in range(nDuplicates):
            if BelongToTaskSleep[i] == 1 or BelongToTaskSleep[j] == 1:  # Sleeptasks can't be connected
                Connected[i][j] = 0
                Connected[j][i] = 0
            if BelongToTaskRest[i] == 1:  # Rest tasks can't have any tasks connected after it
                Connected[i][j] = 0
            if i == j:
                Connected[i][j] = 0  # A task can't be connected to itself


    for i in range(nDuplicates-1):                                  #DirectStart
        if BelongToTaskLong[i] == 1 and BelongToTaskRest[i+1]==1:
            DirectStart[i][i+1] = 1
            DirectStart[i+1][i] = 0
    for i in range(nDuplicates):
        taskisdir = random.choice(dirdistr)
        if taskisdir ==1:
            counter = 0
            nrofdir = random.randint(1,maxtaskdir)
            while counter < nrofdir:
                taskdir = random.randint(0,nDuplicates-1)
                if taskdir !=i and BelongToTaskLong[taskdir] ==0:
                    DirectStart[i][taskdir] = 1
                    counter += 1

    for i in range(nDuplicates):
        for j in range(nDuplicates):
            if BelongToTaskSleep[i] == 1 or BelongToTaskSleep[j] == 1:  # Sleeptasks arent associated with direct starts
                DirectStart[i][j] = 0
                DirectStart[j][i] = 0
            if BelongToTaskRest[i] == 1:
                DirectStart[i][j] = 0
            if Connected[i][j] == 1 and Connected[j][i] == 1:  # Tasks that are connected both ways at the same location, and have...
                if BelongToLocation[i] == BelongToLocation[j]:  # a direct start is equivalent of being a singular task
                    DirectStart[j][i] = 0
                    DirectStart[i][j] = 0
            if DirectStart[i][j] == 1:
                DirectStart[j][i] = 0  # Can't have direct start both ways between two tasks
                Precedence[i][j] = 1  # A task
                Precedence[j][i] = 0
            if i == j:  # A task can't have a direct start after itself
                DirectStart[i][j] = 0

    notlongorsleeptasks = [] #creates list of tasks that can be duplicates
    for i in range(nDuplicates):
        notlongorsleeptasks.append(i+1)

    for i in range(nDuplicates):
        BelongToTaskDuplicate[i] = i + 1  # sets unique tasks
        if BelongToTaskLong[i] == 1:
            notlongorsleeptasks.remove(i+1)
        elif BelongToTaskSleep[i] == 1:
            notlongorsleeptasks.remove(i+1)

    for j in range(nDuplicates, nTasks): #assigns duplicate tasks to unique tasks
        if BelongToTaskDuplicate[j] == 0:
            taskval = random.choice(notlongorsleeptasks)
            BelongToTaskDuplicate[j] = taskval

    a_dup_of = {}
    for i in range(nTasks):
        a_dup_of.update({(i + 1): []})
        a_dup_of[i + 1] = [BelongToTaskDuplicate[i]]

    dup_groups = {}
    for i in range(nDuplicates):
        dup_groups.update({(i + 1): []})
        for j in range(nTasks):
            if BelongToTaskDuplicate[j] == i + 1:
                dup_groups[i + 1].append(j + 1)

    for i in range(nDuplicates,nTasks):                         #Assigns values to the duplicate tasks
        for j in range(1,nDuplicates+1):
            if BelongToTaskDuplicate[i] == j+1:
                BelongToTaskLong[i] = BelongToTaskLong[j]
                BelongToTaskRest[i] = BelongToTaskRest[j]
                BelongToTaskExclusive[i] = BelongToTaskExclusive[j]
                BelongToTaskDivisible[i] = BelongToTaskDivisible[j]
                Tmin[i] = Tmin[j]
                Capmax[i] = Capmax[j]
                BelongToLocation[i] = BelongToLocation[j]
                Ttask[i] = Ttask[j]
                Value[i] = Value[j]

    loc_tasks = {}  # dictionary of which tasks belong to each location
    for l in Location:
        loc_tasks.update({l: []})
    for location, task in loc_tasks.items():
        for i in range(nTasks):
            if BelongToLocation[i] == location:
                loc_tasks[location].append(i + 1)

    task_in_loc = {}  # dictionary of each task and its location
    for i in range(nTasks):
        task_in_loc.update({i + 1: []})
    for task, location in task_in_loc.items():
        for l in Location:
            if BelongToLocation[task - 1] == l:
                task_in_loc[task].append(l)

    MaximumVisits[0] = 1                            #MaximumVisits
    MaximumVisits[nLoc-1] = 1
    for i in range(2,nLoc):
        MaximumVisits[i-1] = len(loc_tasks[i])
    nVisits = max(MaximumVisits)                    #nVisits

    sleep_start = []
    sleep_end = []
    night =[]
    day_start = []
    reg_working_hours =[]
    for d in range(ndays):
        sleep_start.append(16+(d*24))
        sleep_end.append(24+(d*24))
        day_start.append(24+((d-1)*24))
        for i in range(sleep_start[d],sleep_end[d]):
            night.append(i)
        for n in range(day_start[d], sleep_start[d]):
            reg_working_hours.append(n)
    for d in range(ndays):
        if BelongToTaskSleep[d] == 1:
            ReleaseTime[d] = sleep_start[d]
            Deadline[d]  = sleep_end[d]

    for i in range(ndays, nTasks):          #ReleaseTime, Deadline
        if BelongToTaskRest[i] == 1:
            ReleaseTime[i] = 0
            Deadline[i] = nEndTime
        elif BelongToTaskLong[i] == 1:
            ReleaseTime[i] = random.randint(0,nEndTime-72)
            Deadline[i] = random.randint(ReleaseTime[i] + Ttask[i], nEndTime)
        else:
            ReleaseTime[i] = random.choice(reg_working_hours)
            while ReleaseTime[i] + Ttask[i] >= nEndTime or (ReleaseTime[i] + Ttask[i] + DistanceM[BelongToLocation[i]-1][1]) in night:
                ReleaseTime[i] = random.choice(reg_working_hours)
            Deadline[i] = random.randint(ReleaseTime[i]+Ttask[i],nEndTime)
            while Deadline[i] in night:
                Deadline[i] = random.randint(ReleaseTime[i] + Ttask[i], nEndTime)

    preccounter = 0
    dircounter = 0
    concounter = 0
    for i in range(nDuplicates):
        for j in range(nDuplicates):
            if Precedence[i][j] == 1:
                preccounter += 1
            if Connected[i][j] == 1:
                concounter += 1
            if DirectStart[i][j] == 1:
                dircounter += 1

    return BelongToTaskSleep,BelongToTaskDuplicate,BelongToTaskLong, BelongToTaskRest, BelongToTaskExclusive, BelongToTaskDivisible, Tmin, Capmax, BelongToLocation, Ttask, ReleaseTime, Deadline, MaximumVisits, nVisits, Value, Precedence, Connected, DirectStart, preccounter, concounter, dircounter, restcounter
