def getSingleVariables(filepath, parametersSingle):
    with open(filepath, 'r') as infile:
        for line in infile:
            for parameter in parametersSingle.keys():
                if parameter in line:
                    line = line.split(' ') #Parameternavn og data deles med mellomrom
                    parametersSingle[parameter] = int(line[-1].rstrip())


#Skrevet for å takle fles mulige variasjoner. Takler talldeling med " " og med "\t" (tab).
#Takler " " og "\t" på slutten av en linje
#Takler IKKE "parameterNavn : [| 2]" i fila, må ha "parameterNavn: [1 2]"
def getVectorVariables(filepath, parametersVector):
    with open(filepath, 'r') as infile:
        for line in infile:
            for parameter in parametersVector.keys():
                if parameter in line:
                    line.rstrip() #Fjerner mellomrom og newline fra slutten av linja
                    line = line.split() #Deler opp i liste, der hvert element er det som var separert av " " eller "\t"
                    line = line[1:-1] #fjerner første element, som er variabelnavn
                    line[0] = line[0][1:] #Fjerner "[" fra starten av vektor
                    for number in line:
                        parametersVector[parameter].append(float(number))


#Skrevet for å takle fles mulige variasjoner. Takler talldeling med " " og med "\t" (tab).
#Takler " " og "\t" på slutten av en linje
#Takler tomme linjer midt inne i matrisen
#Takler IKKE "parameterNavn : [" i fila, må ha "parameterNavn: ["
#Takler ikke om "[" eller "]" er på samme linje som tall. Må Være:
#"Ttravel: [
#1 2 3
#4 5 6
#]
def getMatrixVariables(filepath, parametersMatrix):
    with open(filepath, 'r') as infile:
        line = 1
        while line: #Dette er gjort anderledes her, fordi matriser spenner flere linjer så vi må kunne gå til neste mens vi jobber
            line = infile.readline()
            for parameter in parametersMatrix.keys():
                if parameter in line:
                    line = infile.readline() #Skipper til neste linje, der faktiske tall begynner
                    while "]" not in line:
                        matrix = []
                        while line != "\n" and "]" not in line:
                            vector = []
                            line.rstrip() #Fjerner mellomrom og newline fra slutten av linja
                            line = line.split() #Deler opp i liste, der hvert element er det som var separert av " " eller "\t"
                            for number in line:
                                vector.append(int(number))
                            if vector: #Sjekker om det faktisk var noe på linja
                                matrix.append(vector)
                            line = infile.readline()
                        parametersMatrix[parameter].append(matrix)
                        if "]" not in line:
                            line = infile.readline()

def getSuperResourceDict(nSuperResources):
    import ast
    with open("battlegrouptypes.txt", 'r') as file:
        for line in file:
            if line[0] == "{":
                superResources = ast.literal_eval(line)
                for key in range(0,len(superResources)+2):
                    if key > nSuperResources:
                        superResources.pop(key, None)
    return superResources

def getSkillDict(nSubResources):
    import ast
    with open("resourceskills.txt", 'r') as file:
        file.readline()
        file.readline()
        data = ''.join(line.rstrip() for line in file)
        skillList = ast.literal_eval(data)
        skillDict = {}
        for i in range(0,len(skillList)):
            skillList[i].insert(0,nSubResources)
            skillDict[i + 1] = skillList[i]
        return skillDict

def getTasksAtLocation(nLocations, BelongToLocation):
    tasksAtLocation = {}
    for loc in range(1,nLocations+1):
        tasksAtLocation[loc] = []
    for i in range(1,len(BelongToLocation)+1):
        tasksAtLocation[BelongToLocation[i-1]].append(i)
    return tasksAtLocation